力扣2200. 找出数组中的所有 K 近邻下标


这一题的大意是说让我们找到一个下标,与它相邻k个单位内的元素中,有没有一个下标对应的值等于key,如果有,那么就说明这个下标符合条件,把下标放到ans数组中,最后返回ans数组。

这一题的数据范围是10^3,可以轻松的暴力通过,难点在于如何用滑动窗口实现O(n),这一题应该也可以用差分加前缀和来实现O(n)的

下面我们来看一下怎么用滑动窗口的方式实现O(n)

首先我们应该找到第一个窗口中,对应的等于key的元素的下标是多少,用last表示,

然后,我们就可以遍历所有的元素,看在该元素所处的滑动窗口中,是否有等于key的元素存在,如果不存在,如果存在我们就可以把遍历到的元素放入到ans数组中,

要注意的是第一个滑动窗口的大小是k,但窗口最大会等于2*k-1,因此,在找是否窗口中有符合条件的下标,只需要last>=i-k即可(大于窗口的左边界)而不是last<=i+k(小于窗口的右边界),为啥不能是小于窗口的右边界呢?(这也是我之前没有AC的原因)因为可能在窗口的移动过程中,某一个窗口中并没有符合条件的下标,那么last就无法被更小,此时last可能是之前的窗口中的下标,如果用last<=i+k(小于窗口的右边界)来判断是否在窗口中有符合条件的下标,就会导致出错,last可能是之前的窗口中的下标。

因此代码如下:

cpp 复制代码
class Solution {
public:
    vector<int> findKDistantIndices(vector<int>& nums, int key, int k) {
        vector<int> ans;
        int n=nums.size();
        int last=0-k-1;
      for(int i=k-1;i>=0;i--)
      {
        if(nums[i]==key)
        {
            last=i;
            break;
        }
      }
      for(int i=0;i<n;i++)
      {
         if(i+k<nums.size()&&nums[i+k]==key)
          {
            last=i+k;
          }
          if(last>=i-k)
          {
              ans.push_back(i);
          }
          
         
      }
       
        return ans;
    }
};

时间复杂度O(n)

相关推荐
青少儿编程课堂7 小时前
树上启发式合并详解:子树颜色众数统计与复杂度拆解
c++·python·算法·bfs·信息学竞赛
hahaha60167 小时前
完美反射法--白平衡算法
人工智能·算法
随意起个昵称8 小时前
【分组背包】洛谷刷题合集
算法·动态规划
elseif1238 小时前
【2026 CSP-J】【逐题精讲】超详细(15道选择,3道阅读,2道完善)
java·开发语言·c++·算法·csp
月光船幽幽8 小时前
拓扑实验三组协同验证方案
python·算法
殷色玫瑰8 小时前
C语言编译和链接:从 .c到 .exe,程序到底经历了什么?
linux·c语言·c++·算法
keep intensify8 小时前
C++20线程池
c++·算法·c++20
奋发向前wcx9 小时前
CSP-J复赛模拟赛2 王晨旭补题 2026.10.3
算法
All for pursuit.9 小时前
【回溯-5】78.子集
数据结构·c++·算法·leetcode
蒲公英eric9 小时前
Python工具链与LaTeX排版:把兵器配齐
人工智能·python·算法·数学建模·数学建模工具